<?php
if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

function doge_MetaData()
{
    return array(
        'DisplayName' => 'doge',
        'DisableLocalCreditCardInput' => true,
    );
}

function doge_config()
{
    return array(
        'FriendlyName' => array(
            'Type' => 'System',
            'Value' => 'Dogecoin',
        ),
        'description' => array(
            'FriendlyName' => 'Description',
            'Type' => 'textarea',
            'Rows' => '3',
            'Cols' => '25',
            'Default' => 'Pay using crypto Dogecoin.',
            'Description' => 'This controls the description which the user sees during checkout.',
        ),
        'blockchain_fees' => array(
            'FriendlyName' => 'Customer pays blockchain fees',
            'Type' => 'yesno',
            'Description' => 'Add estimate blockchain fees to the invoice total.',
            'Default' => 'off',
        ),		
        'wallet_address' => array(
            'FriendlyName' => 'Dogecoin Wallet Address',
            'Type' => 'text',
            'Description' => 'Insert your doge Wallet address.',
        ),
    );
}

function doge_link($params)
{
    $walletAddress = $params['wallet_address'];
    $amount = $params['amount'];
    $invoiceId = $params['invoiceid'];
    $systemUrl = rtrim($params['systemurl'], '/');
    $redirectUrl = $systemUrl . '/modules/gateways/callback/doge.php';
	$invoiceLink = $systemUrl . '/viewinvoice.php?id=' . $invoiceId;
	$allcurrencycryptogateway_doge_currency = $params['currency'];
	$callback_URL = $redirectUrl . '?invoice_id=' . $invoiceId;

		
$allcurrencycryptogateway_doge_response = file_get_contents('https://api.allcurrencygateway.com/crypto/doge/convert.php?value=' . $amount . '&from=' . strtolower($allcurrencycryptogateway_doge_currency));


$allcurrencycryptogateway_doge_conversion_resp = json_decode($allcurrencycryptogateway_doge_response, true);

if ($allcurrencycryptogateway_doge_conversion_resp && isset($allcurrencycryptogateway_doge_conversion_resp['value_coin'])) {
    // Escape output
    $allcurrencycryptogateway_doge_final_total = $allcurrencycryptogateway_doge_conversion_resp['value_coin'];      
} else {
	return "Error: Payment could not be processed, please try again (unsupported store currency)";
}	
		
		if ($params['blockchain_fees'] === 'on') {
			
	$allcurrencycryptogateway_doge_blockchain_response = file_get_contents('https://api.allcurrencygateway.com/crypto/doge/aff-fees.php');


$allcurrencycryptogateway_doge_blockchain_conversion_resp = json_decode($allcurrencycryptogateway_doge_blockchain_response, true);

if ($allcurrencycryptogateway_doge_blockchain_conversion_resp && isset($allcurrencycryptogateway_doge_blockchain_conversion_resp['estimated_cost_currency']['USD'])) {
    
	// revert blockchain fees back to ticker price
$allcurrencycryptogateway_feerevert_doge_response = file_get_contents('https://api.allcurrencygateway.com/crypto/doge/convert.php?value=' . $allcurrencycryptogateway_doge_blockchain_conversion_resp['estimated_cost_currency']['USD'] . '&from=usd');


$allcurrencycryptogateway_feerevert_doge_conversion_resp = json_decode($allcurrencycryptogateway_feerevert_doge_response, true);

if ($allcurrencycryptogateway_feerevert_doge_conversion_resp && isset($allcurrencycryptogateway_feerevert_doge_conversion_resp['value_coin'])) {
    // Escape output
    $allcurrencycryptogateway_feerevert_doge_final_total = $allcurrencycryptogateway_feerevert_doge_conversion_resp['value_coin']; 
// output
    $allcurrencycryptogateway_doge_blockchain_final_total = $allcurrencycryptogateway_feerevert_doge_final_total; 	
} else {
	return "Error: Payment could not be processed, please try again (unable to get estimated cost)";
}
     
} else {
	return "Error: Payment could not be processed, estimated blockchain cost unavailable";
}	

    $allcurrencycryptogateway_doge_amount_to_send = $allcurrencycryptogateway_doge_final_total + $allcurrencycryptogateway_doge_blockchain_final_total;		
	
		} else {
	$allcurrencycryptogateway_doge_amount_to_send = $allcurrencycryptogateway_doge_final_total;		
		}
		
		
		
$allcurrencycryptogatewaycryptogateway_doge_response_minimum = file_get_contents('https://api.allcurrencygateway.com/crypto/doge/info.php');
$allcurrencycryptogatewaycryptogateway_doge_conversion_resp_minimum = json_decode($allcurrencycryptogatewaycryptogateway_doge_response_minimum, true);
if ($allcurrencycryptogatewaycryptogateway_doge_conversion_resp_minimum && isset($allcurrencycryptogatewaycryptogateway_doge_conversion_resp_minimum['minimum'])) {
    $allcurrencycryptogatewaycryptogateway_doge_final_total_minimum = $allcurrencycryptogatewaycryptogateway_doge_conversion_resp_minimum['minimum'];
    if ($allcurrencycryptogateway_doge_amount_to_send < $allcurrencycryptogatewaycryptogateway_doge_final_total_minimum) {
        return "Error: Payment could not be processed, order total crypto amount to send is less than the minimum allowed for the selected coin";
    }
} else {
    return "Error: Payment could not be processed, can't fetch crypto minimum allowed amount";
}
$allcurrencycryptogateway_doge_gen_wallet = file_get_contents('https://api.allcurrencygateway.com/crypto/doge/wallet.php?address=' . $walletAddress .'&callback=' . urlencode($callback_URL));


	$allcurrencycryptogateway_doge_wallet_decbody = json_decode($allcurrencycryptogateway_doge_gen_wallet, true);

 // Check if decoding was successful
    if ($allcurrencycryptogateway_doge_wallet_decbody && isset($allcurrencycryptogateway_doge_wallet_decbody['address_in'])) {
        // Store the address_in as a variable
        $allcurrencycryptogateway_doge_gen_addressIn = $allcurrencycryptogateway_doge_wallet_decbody['address_in'];
		$allcurrencycryptogateway_doge_gen_callback = $allcurrencycryptogateway_doge_wallet_decbody['callback_url'];
		
		$allcurrencycryptogateway_jsonObject = json_encode(array(
'pay_to_address' => $allcurrencycryptogateway_doge_gen_addressIn,
'crypto_amount_to_send' => $allcurrencycryptogateway_doge_amount_to_send,
'coin_to_send' => 'doge'
));

		
		 // Update the invoice description to include address_in
            $invoiceDescription = $allcurrencycryptogateway_jsonObject;

            // Update the invoice with the new description
            $invoice = localAPI("GetInvoice", array('invoiceid' => $invoiceId), null);
            $invoice['notes'] = $invoiceDescription;
            localAPI("UpdateInvoice", $invoice);

		
		
    } else {
return "Error: Payment could not be processed, please try again (wallet address error)";
    }
	
	
        $allcurrencycryptogateway_doge_gen_qrcode = file_get_contents('https://api.allcurrencygateway.com/crypto/doge/qrcode.php?address=' . $allcurrencycryptogateway_doge_gen_addressIn);


	$allcurrencycryptogateway_doge_qrcode_decbody = json_decode($allcurrencycryptogateway_doge_gen_qrcode, true);

 // Check if decoding was successful
    if ($allcurrencycryptogateway_doge_qrcode_decbody && isset($allcurrencycryptogateway_doge_qrcode_decbody['qr_code'])) {
        // Store the qr_code as a variable
        $allcurrencycryptogateway_doge_gen_qrcode = $allcurrencycryptogateway_doge_qrcode_decbody['qr_code'];		
    } else {
return "Error: QR code could not be processed, please try again (wallet address error)";
    }

        // Properly encode attributes for HTML output
        return '<div><img src="data:image/png;base64,' . $allcurrencycryptogateway_doge_gen_qrcode . '" alt="' . $allcurrencycryptogateway_doge_gen_addressIn . '"></div><div>Please send <b>' . $allcurrencycryptogateway_doge_amount_to_send . '</b> doge to the address: <br><b>' . $allcurrencycryptogateway_doge_gen_addressIn . '</b></div>';
}

function doge_activate()
{
    // You can customize activation logic if needed
    return array('status' => 'success', 'description' => 'doge gateway activated successfully.');
}

function doge_deactivate()
{
    // You can customize deactivation logic if needed
    return array('status' => 'success', 'description' => 'doge gateway deactivated successfully.');
}

function doge_upgrade($vars)
{
    // You can customize upgrade logic if needed
}

function doge_output($vars)
{
    // Output additional information if needed
}

function doge_error($vars)
{
    // Handle errors if needed
}
